
USE [Directions2010]  -- change db name
SET STATISTICS IO OFF
SET NOCOUNT ON
GO

SELECT * INTO #tmp_Trace FROM ::fn_trace_gettable('D:\temp\Trace.trc', default)
GO

SELECT 
  [TabName] = 
    (SELECT
    substring(
      convert(varchar(8000), TextData), 
      charindex('."dbo".', convert(varchar(8000), TextData)) + 7,
      charindex('"', convert(varchar(8000), TextData), charindex('."dbo".', convert(varchar(8000), TextData)) + 8)
        - charindex('."dbo".', convert(varchar(8000), TextData)) - 6)
    WHERE (charindex('"', convert(varchar(8000), TextData), charindex('."dbo".', convert(varchar(8000), TextData)) + 8) > 0) 
    and (charindex('."dbo".', convert(varchar(8000), TextData)) > 0)),
  [SELECT] =
    (SELECT
      rtrim(ltrim(substring(
      convert(varchar(8000), TextData), 
      charindex('SELECT', convert(varchar(8000), TextData)) + 6,
      charindex('FROM', convert(varchar(8000), TextData)) - (charindex('SELECT', convert(varchar(8000), TextData)) + 6))))
     WHERE charindex('FROM', convert(varchar(8000), TextData)) > charindex('SELECT', convert(varchar(8000), TextData))),

  [WHERE] =
    (SELECT left(
     substring(
     convert(varchar(8000), TextData), 
     charindex(' WHERE ', convert(varchar(8000), TextData)) + 7,
     len(convert(varchar(8000), TextData)) - charindex(' WHERE ', convert(varchar(8000), TextData)) - 6  
     ), 4000)
     WHERE charindex('WHERE', convert(varchar(8000), TextData)) > 0),

  [ORDER BY] = 
    (SELECT
     substring(
     convert(varchar(8000), TextData), 
     charindex(' ORDER BY ', convert(varchar(8000), TextData)) + 10,
     len(convert(varchar(8000), TextData)) - charindex(' ORDER BY ', convert(varchar(8000), TextData))
     )
     WHERE charindex(' ORDER BY ', convert(varchar(8000), TextData)) > 0),

  [TextData], [Reads], [Writes], [CPU], [Duration] INTO #tmp_TraceCheck
FROM #tmp_Trace
WHERE charindex('SELECT ', convert(varchar(8000), TextData)) > 0
GO

DROP TABLE #tmp_Trace
GO

UPDATE #tmp_TraceCheck
SET [WHERE] = left([WHERE], charindex(''',N', [WHERE]))
WHERE charindex(''',N', [WHERE]) > 0
GO

UPDATE #tmp_TraceCheck
SET [WHERE] = substring([WHERE], 0, charindex('ORDER BY', [WHERE]) - 2)
WHERE charindex('ORDER BY', [WHERE]) > 0
GO

SELECT [TabName], [SELECT], [WHERE], [ORDER BY], AVG([Reads]) as [aReads], AVG([Writes]) as [aWrites], AVG([CPU]) as [aCPU], AVG([Duration]) as [aDuration], COUNT(*) as [Occurrence]
FROM #tmp_TraceCheck
WHERE [TabName] is not null AND [SELECT] is not null
GROUP BY [TabName], [SELECT], [WHERE], [ORDER BY]
HAVING AVG([Reads]) > 10
ORDER BY AVG([Reads]) DESC -- I/O
GO

DROP TABLE #tmp_TraceCheck
GO

